<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestChunkCoding xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/impl/io/TestChunkCoding.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.io;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.ByteArrayOutputStream;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.io.InputStream;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.io.InterruptedIOException;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.io.OutputStream;
<a class="jxr_linenumber" name="35" href="#35">35</a>  
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.MalformedChunkCodingException;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.SessionInputBufferMock;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.SessionOutputBufferMock;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.io.SessionInputBuffer;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.EncodingUtils;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="44" href="#44">44</a>  
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/impl/io/TestChunkCoding.html">TestChunkCoding</a> {
<a class="jxr_linenumber" name="46" href="#46">46</a>  
<a class="jxr_linenumber" name="47" href="#47">47</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String CONTENT_CHARSET = <span class="jxr_string">"ISO-8859-1"</span>;
<a class="jxr_linenumber" name="48" href="#48">48</a>  
<a class="jxr_linenumber" name="49" href="#49">49</a>      @Test
<a class="jxr_linenumber" name="50" href="#50">50</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testConstructors() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="51" href="#51">51</a>          <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="52" href="#52">52</a>              <strong class="jxr_keyword">new</strong> ChunkedInputStream((SessionInputBuffer)<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="53" href="#53">53</a>              Assert.fail(<span class="jxr_string">"IllegalArgumentException should have been thrown"</span>);
<a class="jxr_linenumber" name="54" href="#54">54</a>          } <strong class="jxr_keyword">catch</strong> (IllegalArgumentException ex) {
<a class="jxr_linenumber" name="55" href="#55">55</a>              <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>          }
<a class="jxr_linenumber" name="57" href="#57">57</a>          <strong class="jxr_keyword">new</strong> MalformedChunkCodingException();
<a class="jxr_linenumber" name="58" href="#58">58</a>          <strong class="jxr_keyword">new</strong> MalformedChunkCodingException(<span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="59" href="#59">59</a>      }
<a class="jxr_linenumber" name="60" href="#60">60</a>  
<a class="jxr_linenumber" name="61" href="#61">61</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> String CHUNKED_INPUT
<a class="jxr_linenumber" name="62" href="#62">62</a>          = <span class="jxr_string">"10;key=\&quot;value\&quot;\r\n1234567890123456\r\n5\r\n12345\r\n0\r\nFooter1: abcde\r\nFooter2: fghij\r\n"</span>;
<a class="jxr_linenumber" name="63" href="#63">63</a>  
<a class="jxr_linenumber" name="64" href="#64">64</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">static</strong> String CHUNKED_RESULT
<a class="jxr_linenumber" name="65" href="#65">65</a>          = <span class="jxr_string">"123456789012345612345"</span>;
<a class="jxr_linenumber" name="66" href="#66">66</a>  
<a class="jxr_linenumber" name="67" href="#67">67</a>      <em class="jxr_comment">// Test for when buffer is larger than chunk size</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>      @Test
<a class="jxr_linenumber" name="69" href="#69">69</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedInputStreamLargeBuffer() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="70" href="#70">70</a>          ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="71" href="#71">71</a>                  <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="72" href="#72">72</a>                          EncodingUtils.getBytes(CHUNKED_INPUT, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="73" href="#73">73</a>          byte[] buffer = <strong class="jxr_keyword">new</strong> byte[300];
<a class="jxr_linenumber" name="74" href="#74">74</a>          ByteArrayOutputStream out = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="75" href="#75">75</a>          <strong class="jxr_keyword">int</strong> len;
<a class="jxr_linenumber" name="76" href="#76">76</a>          <strong class="jxr_keyword">while</strong> ((len = in.read(buffer)) &gt; 0) {
<a class="jxr_linenumber" name="77" href="#77">77</a>              out.write(buffer, 0, len);
<a class="jxr_linenumber" name="78" href="#78">78</a>          }
<a class="jxr_linenumber" name="79" href="#79">79</a>          Assert.assertEquals(-1, in.read(buffer));
<a class="jxr_linenumber" name="80" href="#80">80</a>          Assert.assertEquals(-1, in.read(buffer));
<a class="jxr_linenumber" name="81" href="#81">81</a>  
<a class="jxr_linenumber" name="82" href="#82">82</a>          in.close();
<a class="jxr_linenumber" name="83" href="#83">83</a>  
<a class="jxr_linenumber" name="84" href="#84">84</a>          String result = EncodingUtils.getString(out.toByteArray(), CONTENT_CHARSET);
<a class="jxr_linenumber" name="85" href="#85">85</a>          Assert.assertEquals(result, CHUNKED_RESULT);
<a class="jxr_linenumber" name="86" href="#86">86</a>  
<a class="jxr_linenumber" name="87" href="#87">87</a>          Header[] footers = in.getFooters();
<a class="jxr_linenumber" name="88" href="#88">88</a>          Assert.assertNotNull(footers);
<a class="jxr_linenumber" name="89" href="#89">89</a>          Assert.assertEquals(2, footers.length);
<a class="jxr_linenumber" name="90" href="#90">90</a>          Assert.assertEquals(<span class="jxr_string">"Footer1"</span>, footers[0].getName());
<a class="jxr_linenumber" name="91" href="#91">91</a>          Assert.assertEquals(<span class="jxr_string">"abcde"</span>, footers[0].getValue());
<a class="jxr_linenumber" name="92" href="#92">92</a>          Assert.assertEquals(<span class="jxr_string">"Footer2"</span>, footers[1].getName());
<a class="jxr_linenumber" name="93" href="#93">93</a>          Assert.assertEquals(<span class="jxr_string">"fghij"</span>, footers[1].getValue());
<a class="jxr_linenumber" name="94" href="#94">94</a>      }
<a class="jxr_linenumber" name="95" href="#95">95</a>  
<a class="jxr_linenumber" name="96" href="#96">96</a>      <em class="jxr_comment">//Test for when buffer is smaller than chunk size.</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>      @Test
<a class="jxr_linenumber" name="98" href="#98">98</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedInputStreamSmallBuffer() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="99" href="#99">99</a>          ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="100" href="#100">100</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="101" href="#101">101</a>                             EncodingUtils.getBytes(CHUNKED_INPUT, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="102" href="#102">102</a> 
<a class="jxr_linenumber" name="103" href="#103">103</a>         byte[] buffer = <strong class="jxr_keyword">new</strong> byte[7];
<a class="jxr_linenumber" name="104" href="#104">104</a>         ByteArrayOutputStream out = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="105" href="#105">105</a>         <strong class="jxr_keyword">int</strong> len;
<a class="jxr_linenumber" name="106" href="#106">106</a>         <strong class="jxr_keyword">while</strong> ((len = in.read(buffer)) &gt; 0) {
<a class="jxr_linenumber" name="107" href="#107">107</a>             out.write(buffer, 0, len);
<a class="jxr_linenumber" name="108" href="#108">108</a>         }
<a class="jxr_linenumber" name="109" href="#109">109</a>         Assert.assertEquals(-1, in.read(buffer));
<a class="jxr_linenumber" name="110" href="#110">110</a>         Assert.assertEquals(-1, in.read(buffer));
<a class="jxr_linenumber" name="111" href="#111">111</a> 
<a class="jxr_linenumber" name="112" href="#112">112</a>         in.close();
<a class="jxr_linenumber" name="113" href="#113">113</a> 
<a class="jxr_linenumber" name="114" href="#114">114</a>         EncodingUtils.getString(out.toByteArray(), CONTENT_CHARSET);
<a class="jxr_linenumber" name="115" href="#115">115</a>         Header[] footers = in.getFooters();
<a class="jxr_linenumber" name="116" href="#116">116</a>         Assert.assertNotNull(footers);
<a class="jxr_linenumber" name="117" href="#117">117</a>         Assert.assertEquals(2, footers.length);
<a class="jxr_linenumber" name="118" href="#118">118</a>         Assert.assertEquals(<span class="jxr_string">"Footer1"</span>, footers[0].getName());
<a class="jxr_linenumber" name="119" href="#119">119</a>         Assert.assertEquals(<span class="jxr_string">"abcde"</span>, footers[0].getValue());
<a class="jxr_linenumber" name="120" href="#120">120</a>         Assert.assertEquals(<span class="jxr_string">"Footer2"</span>, footers[1].getName());
<a class="jxr_linenumber" name="121" href="#121">121</a>         Assert.assertEquals(<span class="jxr_string">"fghij"</span>, footers[1].getValue());
<a class="jxr_linenumber" name="122" href="#122">122</a>     }
<a class="jxr_linenumber" name="123" href="#123">123</a> 
<a class="jxr_linenumber" name="124" href="#124">124</a>     <em class="jxr_comment">// One byte read</em>
<a class="jxr_linenumber" name="125" href="#125">125</a>     @Test
<a class="jxr_linenumber" name="126" href="#126">126</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedInputStreamOneByteRead() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="127" href="#127">127</a>         String s = <span class="jxr_string">"5\r\n01234\r\n5\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="128" href="#128">128</a>         ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="129" href="#129">129</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="130" href="#130">130</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="131" href="#131">131</a>         <strong class="jxr_keyword">int</strong> ch;
<a class="jxr_linenumber" name="132" href="#132">132</a>         <strong class="jxr_keyword">int</strong> i = '0';
<a class="jxr_linenumber" name="133" href="#133">133</a>         <strong class="jxr_keyword">while</strong> ((ch = in.read()) != -1) {
<a class="jxr_linenumber" name="134" href="#134">134</a>             Assert.assertEquals(i, ch);
<a class="jxr_linenumber" name="135" href="#135">135</a>             i++;
<a class="jxr_linenumber" name="136" href="#136">136</a>         }
<a class="jxr_linenumber" name="137" href="#137">137</a>         Assert.assertEquals(-1, in.read());
<a class="jxr_linenumber" name="138" href="#138">138</a>         Assert.assertEquals(-1, in.read());
<a class="jxr_linenumber" name="139" href="#139">139</a> 
<a class="jxr_linenumber" name="140" href="#140">140</a>         in.close();
<a class="jxr_linenumber" name="141" href="#141">141</a>     }
<a class="jxr_linenumber" name="142" href="#142">142</a> 
<a class="jxr_linenumber" name="143" href="#143">143</a>     @Test
<a class="jxr_linenumber" name="144" href="#144">144</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testAvailable() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="145" href="#145">145</a>         String s = <span class="jxr_string">"5\r\n12345\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="146" href="#146">146</a>         ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="147" href="#147">147</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="148" href="#148">148</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="149" href="#149">149</a>         Assert.assertEquals(0, in.available());
<a class="jxr_linenumber" name="150" href="#150">150</a>         in.read();
<a class="jxr_linenumber" name="151" href="#151">151</a>         Assert.assertEquals(4, in.available());
<a class="jxr_linenumber" name="152" href="#152">152</a>     }
<a class="jxr_linenumber" name="153" href="#153">153</a> 
<a class="jxr_linenumber" name="154" href="#154">154</a>     @Test
<a class="jxr_linenumber" name="155" href="#155">155</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedInputStreamClose() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="156" href="#156">156</a>         String s = <span class="jxr_string">"5\r\n01234\r\n5\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="157" href="#157">157</a>         ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="158" href="#158">158</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="159" href="#159">159</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="160" href="#160">160</a>         in.close();
<a class="jxr_linenumber" name="161" href="#161">161</a>         in.close();
<a class="jxr_linenumber" name="162" href="#162">162</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="163" href="#163">163</a>             in.read();
<a class="jxr_linenumber" name="164" href="#164">164</a>             Assert.fail(<span class="jxr_string">"IOException should have been thrown"</span>);
<a class="jxr_linenumber" name="165" href="#165">165</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="166" href="#166">166</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="167" href="#167">167</a>         }
<a class="jxr_linenumber" name="168" href="#168">168</a>         byte[] tmp = <strong class="jxr_keyword">new</strong> byte[10];
<a class="jxr_linenumber" name="169" href="#169">169</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="170" href="#170">170</a>             in.read(tmp);
<a class="jxr_linenumber" name="171" href="#171">171</a>             Assert.fail(<span class="jxr_string">"IOException should have been thrown"</span>);
<a class="jxr_linenumber" name="172" href="#172">172</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="173" href="#173">173</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="174" href="#174">174</a>         }
<a class="jxr_linenumber" name="175" href="#175">175</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="176" href="#176">176</a>             in.read(tmp, 0, tmp.length);
<a class="jxr_linenumber" name="177" href="#177">177</a>             Assert.fail(<span class="jxr_string">"IOException should have been thrown"</span>);
<a class="jxr_linenumber" name="178" href="#178">178</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="179" href="#179">179</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="180" href="#180">180</a>         }
<a class="jxr_linenumber" name="181" href="#181">181</a>     }
<a class="jxr_linenumber" name="182" href="#182">182</a> 
<a class="jxr_linenumber" name="183" href="#183">183</a>     @Test
<a class="jxr_linenumber" name="184" href="#184">184</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedOutputStreamClose() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="185" href="#185">185</a>         ChunkedOutputStream out = <strong class="jxr_keyword">new</strong> ChunkedOutputStream(
<a class="jxr_linenumber" name="186" href="#186">186</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a>());
<a class="jxr_linenumber" name="187" href="#187">187</a>         out.close();
<a class="jxr_linenumber" name="188" href="#188">188</a>         out.close();
<a class="jxr_linenumber" name="189" href="#189">189</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="190" href="#190">190</a>             out.write(<strong class="jxr_keyword">new</strong> byte[] {1,2,3});
<a class="jxr_linenumber" name="191" href="#191">191</a>             Assert.fail(<span class="jxr_string">"IOException should have been thrown"</span>);
<a class="jxr_linenumber" name="192" href="#192">192</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="193" href="#193">193</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="194" href="#194">194</a>         }
<a class="jxr_linenumber" name="195" href="#195">195</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="196" href="#196">196</a>             out.write(1);
<a class="jxr_linenumber" name="197" href="#197">197</a>             Assert.fail(<span class="jxr_string">"IOException should have been thrown"</span>);
<a class="jxr_linenumber" name="198" href="#198">198</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="199" href="#199">199</a>             <em class="jxr_comment">// expected</em>
<a class="jxr_linenumber" name="200" href="#200">200</a>         }
<a class="jxr_linenumber" name="201" href="#201">201</a>     }
<a class="jxr_linenumber" name="202" href="#202">202</a> 
<a class="jxr_linenumber" name="203" href="#203">203</a>     <em class="jxr_comment">// Missing closing chunk</em>
<a class="jxr_linenumber" name="204" href="#204">204</a>     @Test
<a class="jxr_linenumber" name="205" href="#205">205</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedInputStreamNoClosingChunk() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="206" href="#206">206</a>         String s = <span class="jxr_string">"5\r\n01234\r\n"</span>;
<a class="jxr_linenumber" name="207" href="#207">207</a>         ChunkedInputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="208" href="#208">208</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="209" href="#209">209</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="210" href="#210">210</a>         byte[] tmp = <strong class="jxr_keyword">new</strong> byte[5];
<a class="jxr_linenumber" name="211" href="#211">211</a>         Assert.assertEquals(5, in.read(tmp));
<a class="jxr_linenumber" name="212" href="#212">212</a>         Assert.assertEquals(-1, in.read());
<a class="jxr_linenumber" name="213" href="#213">213</a>     }
<a class="jxr_linenumber" name="214" href="#214">214</a> 
<a class="jxr_linenumber" name="215" href="#215">215</a>     <em class="jxr_comment">// Missing \r\n at the end of the first chunk</em>
<a class="jxr_linenumber" name="216" href="#216">216</a>     @Test
<a class="jxr_linenumber" name="217" href="#217">217</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamMissingCRLF() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="218" href="#218">218</a>         String s = <span class="jxr_string">"5\r\n012345\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="219" href="#219">219</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="220" href="#220">220</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="221" href="#221">221</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="222" href="#222">222</a>         byte[] buffer = <strong class="jxr_keyword">new</strong> byte[300];
<a class="jxr_linenumber" name="223" href="#223">223</a>         ByteArrayOutputStream out = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="224" href="#224">224</a>         <strong class="jxr_keyword">int</strong> len;
<a class="jxr_linenumber" name="225" href="#225">225</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="226" href="#226">226</a>             <strong class="jxr_keyword">while</strong> ((len = in.read(buffer)) &gt; 0) {
<a class="jxr_linenumber" name="227" href="#227">227</a>                 out.write(buffer, 0, len);
<a class="jxr_linenumber" name="228" href="#228">228</a>             }
<a class="jxr_linenumber" name="229" href="#229">229</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="230" href="#230">230</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="231" href="#231">231</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="232" href="#232">232</a>         }
<a class="jxr_linenumber" name="233" href="#233">233</a>     }
<a class="jxr_linenumber" name="234" href="#234">234</a> 
<a class="jxr_linenumber" name="235" href="#235">235</a>     <em class="jxr_comment">// Missing LF</em>
<a class="jxr_linenumber" name="236" href="#236">236</a>     @Test
<a class="jxr_linenumber" name="237" href="#237">237</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamMissingLF() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="238" href="#238">238</a>         String s = <span class="jxr_string">"5\r01234\r\n5\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="239" href="#239">239</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="240" href="#240">240</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="241" href="#241">241</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="242" href="#242">242</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="243" href="#243">243</a>             in.read();
<a class="jxr_linenumber" name="244" href="#244">244</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="245" href="#245">245</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="246" href="#246">246</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="247" href="#247">247</a>         }
<a class="jxr_linenumber" name="248" href="#248">248</a>     }
<a class="jxr_linenumber" name="249" href="#249">249</a> 
<a class="jxr_linenumber" name="250" href="#250">250</a>     <em class="jxr_comment">// Invalid chunk size</em>
<a class="jxr_linenumber" name="251" href="#251">251</a>     @Test
<a class="jxr_linenumber" name="252" href="#252">252</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamInvalidSize() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="253" href="#253">253</a>         String s = <span class="jxr_string">"whatever\r\n01234\r\n5\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="254" href="#254">254</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="255" href="#255">255</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="256" href="#256">256</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="257" href="#257">257</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="258" href="#258">258</a>             in.read();
<a class="jxr_linenumber" name="259" href="#259">259</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="260" href="#260">260</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="261" href="#261">261</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="262" href="#262">262</a>         }
<a class="jxr_linenumber" name="263" href="#263">263</a>     }
<a class="jxr_linenumber" name="264" href="#264">264</a> 
<a class="jxr_linenumber" name="265" href="#265">265</a>     <em class="jxr_comment">// Negative chunk size</em>
<a class="jxr_linenumber" name="266" href="#266">266</a>     @Test
<a class="jxr_linenumber" name="267" href="#267">267</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamNegativeSize() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="268" href="#268">268</a>         String s = <span class="jxr_string">"-5\r\n01234\r\n5\r\n56789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="269" href="#269">269</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="270" href="#270">270</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="271" href="#271">271</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="272" href="#272">272</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="273" href="#273">273</a>             in.read();
<a class="jxr_linenumber" name="274" href="#274">274</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="275" href="#275">275</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="276" href="#276">276</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="277" href="#277">277</a>         }
<a class="jxr_linenumber" name="278" href="#278">278</a>     }
<a class="jxr_linenumber" name="279" href="#279">279</a> 
<a class="jxr_linenumber" name="280" href="#280">280</a>     <em class="jxr_comment">// Truncated chunk</em>
<a class="jxr_linenumber" name="281" href="#281">281</a>     @Test
<a class="jxr_linenumber" name="282" href="#282">282</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamTruncatedChunk() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="283" href="#283">283</a>         String s = <span class="jxr_string">"3\r\n12"</span>;
<a class="jxr_linenumber" name="284" href="#284">284</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="285" href="#285">285</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="286" href="#286">286</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="287" href="#287">287</a>         byte[] buffer = <strong class="jxr_keyword">new</strong> byte[300];
<a class="jxr_linenumber" name="288" href="#288">288</a>         Assert.assertEquals(2, in.read(buffer));
<a class="jxr_linenumber" name="289" href="#289">289</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="290" href="#290">290</a>             in.read(buffer);
<a class="jxr_linenumber" name="291" href="#291">291</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="292" href="#292">292</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="293" href="#293">293</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="294" href="#294">294</a>         }
<a class="jxr_linenumber" name="295" href="#295">295</a>     }
<a class="jxr_linenumber" name="296" href="#296">296</a> 
<a class="jxr_linenumber" name="297" href="#297">297</a>     <em class="jxr_comment">// Invalid footer</em>
<a class="jxr_linenumber" name="298" href="#298">298</a>     @Test
<a class="jxr_linenumber" name="299" href="#299">299</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCorruptChunkedInputStreamInvalidFooter() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="300" href="#300">300</a>         String s = <span class="jxr_string">"1\r\n0\r\n0\r\nstuff\r\n"</span>;
<a class="jxr_linenumber" name="301" href="#301">301</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="302" href="#302">302</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="303" href="#303">303</a>                         EncodingUtils.getBytes(s, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="304" href="#304">304</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="305" href="#305">305</a>             in.read();
<a class="jxr_linenumber" name="306" href="#306">306</a>             in.read();
<a class="jxr_linenumber" name="307" href="#307">307</a>             Assert.fail(<span class="jxr_string">"MalformedChunkCodingException should have been thrown"</span>);
<a class="jxr_linenumber" name="308" href="#308">308</a>         } <strong class="jxr_keyword">catch</strong>(MalformedChunkCodingException e) {
<a class="jxr_linenumber" name="309" href="#309">309</a>             <em class="jxr_comment">/*<em class="jxr_comment"> expected exception */</em></em>
<a class="jxr_linenumber" name="310" href="#310">310</a>         }
<a class="jxr_linenumber" name="311" href="#311">311</a>     }
<a class="jxr_linenumber" name="312" href="#312">312</a> 
<a class="jxr_linenumber" name="313" href="#313">313</a>     @Test
<a class="jxr_linenumber" name="314" href="#314">314</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testEmptyChunkedInputStream() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="315" href="#315">315</a>         String input = <span class="jxr_string">"0\r\n"</span>;
<a class="jxr_linenumber" name="316" href="#316">316</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="317" href="#317">317</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="318" href="#318">318</a>                         EncodingUtils.getBytes(input, CONTENT_CHARSET)));
<a class="jxr_linenumber" name="319" href="#319">319</a>         byte[] buffer = <strong class="jxr_keyword">new</strong> byte[300];
<a class="jxr_linenumber" name="320" href="#320">320</a>         ByteArrayOutputStream out = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="321" href="#321">321</a>         <strong class="jxr_keyword">int</strong> len;
<a class="jxr_linenumber" name="322" href="#322">322</a>         <strong class="jxr_keyword">while</strong> ((len = in.read(buffer)) &gt; 0) {
<a class="jxr_linenumber" name="323" href="#323">323</a>             out.write(buffer, 0, len);
<a class="jxr_linenumber" name="324" href="#324">324</a>         }
<a class="jxr_linenumber" name="325" href="#325">325</a>         Assert.assertEquals(0, out.size());
<a class="jxr_linenumber" name="326" href="#326">326</a>     }
<a class="jxr_linenumber" name="327" href="#327">327</a> 
<a class="jxr_linenumber" name="328" href="#328">328</a>     @Test
<a class="jxr_linenumber" name="329" href="#329">329</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedConsistence() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="330" href="#330">330</a>         String input = <span class="jxr_string">"76126;27823abcd;:q38a-\nkjc\rk%1ad\tkh/asdui\r\njkh+?&#92;&#92;suweb"</span>;
<a class="jxr_linenumber" name="331" href="#331">331</a>         ByteArrayOutputStream buffer = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="332" href="#332">332</a>         OutputStream out = <strong class="jxr_keyword">new</strong> ChunkedOutputStream(<strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a>(buffer));
<a class="jxr_linenumber" name="333" href="#333">333</a>         out.write(EncodingUtils.getBytes(input, CONTENT_CHARSET));
<a class="jxr_linenumber" name="334" href="#334">334</a>         out.flush();
<a class="jxr_linenumber" name="335" href="#335">335</a>         out.close();
<a class="jxr_linenumber" name="336" href="#336">336</a>         out.close();
<a class="jxr_linenumber" name="337" href="#337">337</a>         buffer.close();
<a class="jxr_linenumber" name="338" href="#338">338</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(
<a class="jxr_linenumber" name="339" href="#339">339</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="340" href="#340">340</a>                         buffer.toByteArray()));
<a class="jxr_linenumber" name="341" href="#341">341</a> 
<a class="jxr_linenumber" name="342" href="#342">342</a>         byte[] d = <strong class="jxr_keyword">new</strong> byte[10];
<a class="jxr_linenumber" name="343" href="#343">343</a>         ByteArrayOutputStream result = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="344" href="#344">344</a>         <strong class="jxr_keyword">int</strong> len = 0;
<a class="jxr_linenumber" name="345" href="#345">345</a>         <strong class="jxr_keyword">while</strong> ((len = in.read(d)) &gt; 0) {
<a class="jxr_linenumber" name="346" href="#346">346</a>             result.write(d, 0, len);
<a class="jxr_linenumber" name="347" href="#347">347</a>         }
<a class="jxr_linenumber" name="348" href="#348">348</a> 
<a class="jxr_linenumber" name="349" href="#349">349</a>         String output = EncodingUtils.getString(result.toByteArray(), CONTENT_CHARSET);
<a class="jxr_linenumber" name="350" href="#350">350</a>         Assert.assertEquals(input, output);
<a class="jxr_linenumber" name="351" href="#351">351</a>     }
<a class="jxr_linenumber" name="352" href="#352">352</a> 
<a class="jxr_linenumber" name="353" href="#353">353</a>     @Test
<a class="jxr_linenumber" name="354" href="#354">354</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedOutputStream() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="355" href="#355">355</a>         <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a> buffer = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a>();
<a class="jxr_linenumber" name="356" href="#356">356</a>         ChunkedOutputStream out = <strong class="jxr_keyword">new</strong> ChunkedOutputStream(buffer, 2);
<a class="jxr_linenumber" name="357" href="#357">357</a>         out.write('1');
<a class="jxr_linenumber" name="358" href="#358">358</a>         out.write('2');
<a class="jxr_linenumber" name="359" href="#359">359</a>         out.write('3');
<a class="jxr_linenumber" name="360" href="#360">360</a>         out.write('4');
<a class="jxr_linenumber" name="361" href="#361">361</a>         out.finish();
<a class="jxr_linenumber" name="362" href="#362">362</a>         out.close();
<a class="jxr_linenumber" name="363" href="#363">363</a> 
<a class="jxr_linenumber" name="364" href="#364">364</a>         byte [] rawdata =  buffer.getData();
<a class="jxr_linenumber" name="365" href="#365">365</a> 
<a class="jxr_linenumber" name="366" href="#366">366</a>         Assert.assertEquals(19, rawdata.length);
<a class="jxr_linenumber" name="367" href="#367">367</a>         Assert.assertEquals('2', rawdata[0]);
<a class="jxr_linenumber" name="368" href="#368">368</a>         Assert.assertEquals('\r', rawdata[1]);
<a class="jxr_linenumber" name="369" href="#369">369</a>         Assert.assertEquals('\n', rawdata[2]);
<a class="jxr_linenumber" name="370" href="#370">370</a>         Assert.assertEquals('1', rawdata[3]);
<a class="jxr_linenumber" name="371" href="#371">371</a>         Assert.assertEquals('2', rawdata[4]);
<a class="jxr_linenumber" name="372" href="#372">372</a>         Assert.assertEquals('\r', rawdata[5]);
<a class="jxr_linenumber" name="373" href="#373">373</a>         Assert.assertEquals('\n', rawdata[6]);
<a class="jxr_linenumber" name="374" href="#374">374</a>         Assert.assertEquals('2', rawdata[7]);
<a class="jxr_linenumber" name="375" href="#375">375</a>         Assert.assertEquals('\r', rawdata[8]);
<a class="jxr_linenumber" name="376" href="#376">376</a>         Assert.assertEquals('\n', rawdata[9]);
<a class="jxr_linenumber" name="377" href="#377">377</a>         Assert.assertEquals('3', rawdata[10]);
<a class="jxr_linenumber" name="378" href="#378">378</a>         Assert.assertEquals('4', rawdata[11]);
<a class="jxr_linenumber" name="379" href="#379">379</a>         Assert.assertEquals('\r', rawdata[12]);
<a class="jxr_linenumber" name="380" href="#380">380</a>         Assert.assertEquals('\n', rawdata[13]);
<a class="jxr_linenumber" name="381" href="#381">381</a>         Assert.assertEquals('0', rawdata[14]);
<a class="jxr_linenumber" name="382" href="#382">382</a>         Assert.assertEquals('\r', rawdata[15]);
<a class="jxr_linenumber" name="383" href="#383">383</a>         Assert.assertEquals('\n', rawdata[16]);
<a class="jxr_linenumber" name="384" href="#384">384</a>         Assert.assertEquals('\r', rawdata[17]);
<a class="jxr_linenumber" name="385" href="#385">385</a>         Assert.assertEquals('\n', rawdata[18]);
<a class="jxr_linenumber" name="386" href="#386">386</a>     }
<a class="jxr_linenumber" name="387" href="#387">387</a> 
<a class="jxr_linenumber" name="388" href="#388">388</a>     @Test
<a class="jxr_linenumber" name="389" href="#389">389</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedOutputStreamLargeChunk() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="390" href="#390">390</a>         <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a> buffer = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a>();
<a class="jxr_linenumber" name="391" href="#391">391</a>         ChunkedOutputStream out = <strong class="jxr_keyword">new</strong> ChunkedOutputStream(buffer, 2);
<a class="jxr_linenumber" name="392" href="#392">392</a>         out.write(<strong class="jxr_keyword">new</strong> byte[] {'1', '2', '3', '4'});
<a class="jxr_linenumber" name="393" href="#393">393</a>         out.finish();
<a class="jxr_linenumber" name="394" href="#394">394</a>         out.close();
<a class="jxr_linenumber" name="395" href="#395">395</a> 
<a class="jxr_linenumber" name="396" href="#396">396</a>         byte [] rawdata =  buffer.getData();
<a class="jxr_linenumber" name="397" href="#397">397</a> 
<a class="jxr_linenumber" name="398" href="#398">398</a>         Assert.assertEquals(14, rawdata.length);
<a class="jxr_linenumber" name="399" href="#399">399</a>         Assert.assertEquals('4', rawdata[0]);
<a class="jxr_linenumber" name="400" href="#400">400</a>         Assert.assertEquals('\r', rawdata[1]);
<a class="jxr_linenumber" name="401" href="#401">401</a>         Assert.assertEquals('\n', rawdata[2]);
<a class="jxr_linenumber" name="402" href="#402">402</a>         Assert.assertEquals('1', rawdata[3]);
<a class="jxr_linenumber" name="403" href="#403">403</a>         Assert.assertEquals('2', rawdata[4]);
<a class="jxr_linenumber" name="404" href="#404">404</a>         Assert.assertEquals('3', rawdata[5]);
<a class="jxr_linenumber" name="405" href="#405">405</a>         Assert.assertEquals('4', rawdata[6]);
<a class="jxr_linenumber" name="406" href="#406">406</a>         Assert.assertEquals('\r', rawdata[7]);
<a class="jxr_linenumber" name="407" href="#407">407</a>         Assert.assertEquals('\n', rawdata[8]);
<a class="jxr_linenumber" name="408" href="#408">408</a>         Assert.assertEquals('0', rawdata[9]);
<a class="jxr_linenumber" name="409" href="#409">409</a>         Assert.assertEquals('\r', rawdata[10]);
<a class="jxr_linenumber" name="410" href="#410">410</a>         Assert.assertEquals('\n', rawdata[11]);
<a class="jxr_linenumber" name="411" href="#411">411</a>         Assert.assertEquals('\r', rawdata[12]);
<a class="jxr_linenumber" name="412" href="#412">412</a>         Assert.assertEquals('\n', rawdata[13]);
<a class="jxr_linenumber" name="413" href="#413">413</a>     }
<a class="jxr_linenumber" name="414" href="#414">414</a> 
<a class="jxr_linenumber" name="415" href="#415">415</a>     @Test
<a class="jxr_linenumber" name="416" href="#416">416</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testChunkedOutputStreamSmallChunk() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="417" href="#417">417</a>         ByteArrayOutputStream buffer = <strong class="jxr_keyword">new</strong> ByteArrayOutputStream();
<a class="jxr_linenumber" name="418" href="#418">418</a>         ChunkedOutputStream out = <strong class="jxr_keyword">new</strong> ChunkedOutputStream(
<a class="jxr_linenumber" name="419" href="#419">419</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionOutputBufferMock.html">SessionOutputBufferMock</a>(buffer), 2);
<a class="jxr_linenumber" name="420" href="#420">420</a>         out.write('1');
<a class="jxr_linenumber" name="421" href="#421">421</a>         out.finish();
<a class="jxr_linenumber" name="422" href="#422">422</a>         out.close();
<a class="jxr_linenumber" name="423" href="#423">423</a> 
<a class="jxr_linenumber" name="424" href="#424">424</a>         byte [] rawdata =  buffer.toByteArray();
<a class="jxr_linenumber" name="425" href="#425">425</a> 
<a class="jxr_linenumber" name="426" href="#426">426</a>         Assert.assertEquals(11, rawdata.length);
<a class="jxr_linenumber" name="427" href="#427">427</a>         Assert.assertEquals('1', rawdata[0]);
<a class="jxr_linenumber" name="428" href="#428">428</a>         Assert.assertEquals('\r', rawdata[1]);
<a class="jxr_linenumber" name="429" href="#429">429</a>         Assert.assertEquals('\n', rawdata[2]);
<a class="jxr_linenumber" name="430" href="#430">430</a>         Assert.assertEquals('1', rawdata[3]);
<a class="jxr_linenumber" name="431" href="#431">431</a>         Assert.assertEquals('\r', rawdata[4]);
<a class="jxr_linenumber" name="432" href="#432">432</a>         Assert.assertEquals('\n', rawdata[5]);
<a class="jxr_linenumber" name="433" href="#433">433</a>         Assert.assertEquals('0', rawdata[6]);
<a class="jxr_linenumber" name="434" href="#434">434</a>         Assert.assertEquals('\r', rawdata[7]);
<a class="jxr_linenumber" name="435" href="#435">435</a>         Assert.assertEquals('\n', rawdata[8]);
<a class="jxr_linenumber" name="436" href="#436">436</a>         Assert.assertEquals('\r', rawdata[9]);
<a class="jxr_linenumber" name="437" href="#437">437</a>         Assert.assertEquals('\n', rawdata[10]);
<a class="jxr_linenumber" name="438" href="#438">438</a>     }
<a class="jxr_linenumber" name="439" href="#439">439</a> 
<a class="jxr_linenumber" name="440" href="#440">440</a>     @Test
<a class="jxr_linenumber" name="441" href="#441">441</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testResumeOnSocketTimeoutInData() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="442" href="#442">442</a>         String s = <span class="jxr_string">"5\r\n01234\r\n5\r\n5\0006789\r\na\r\n0123\000456789\r\n0\r\n"</span>;
<a class="jxr_linenumber" name="443" href="#443">443</a>         SessionInputBuffer sessbuf = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="444" href="#444">444</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/io/TimeoutByteArrayInputStream.html">TimeoutByteArrayInputStream</a>(s.getBytes(<span class="jxr_string">"ISO-8859-1"</span>)), 16);
<a class="jxr_linenumber" name="445" href="#445">445</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(sessbuf);
<a class="jxr_linenumber" name="446" href="#446">446</a> 
<a class="jxr_linenumber" name="447" href="#447">447</a>         byte[] tmp = <strong class="jxr_keyword">new</strong> byte[3];
<a class="jxr_linenumber" name="448" href="#448">448</a> 
<a class="jxr_linenumber" name="449" href="#449">449</a>         <strong class="jxr_keyword">int</strong> bytesRead = 0;
<a class="jxr_linenumber" name="450" href="#450">450</a>         <strong class="jxr_keyword">int</strong> timeouts = 0;
<a class="jxr_linenumber" name="451" href="#451">451</a> 
<a class="jxr_linenumber" name="452" href="#452">452</a>         <strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="453" href="#453">453</a>         <strong class="jxr_keyword">while</strong> (i != -1) {
<a class="jxr_linenumber" name="454" href="#454">454</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="455" href="#455">455</a>                 i = in.read(tmp);
<a class="jxr_linenumber" name="456" href="#456">456</a>                 <strong class="jxr_keyword">if</strong> (i &gt; 0) {
<a class="jxr_linenumber" name="457" href="#457">457</a>                     bytesRead += i;
<a class="jxr_linenumber" name="458" href="#458">458</a>                 }
<a class="jxr_linenumber" name="459" href="#459">459</a>             } <strong class="jxr_keyword">catch</strong> (InterruptedIOException ex) {
<a class="jxr_linenumber" name="460" href="#460">460</a>                 timeouts++;
<a class="jxr_linenumber" name="461" href="#461">461</a>             }
<a class="jxr_linenumber" name="462" href="#462">462</a>         }
<a class="jxr_linenumber" name="463" href="#463">463</a>         Assert.assertEquals(20, bytesRead);
<a class="jxr_linenumber" name="464" href="#464">464</a>         Assert.assertEquals(2, timeouts);
<a class="jxr_linenumber" name="465" href="#465">465</a>     }
<a class="jxr_linenumber" name="466" href="#466">466</a> 
<a class="jxr_linenumber" name="467" href="#467">467</a>     @Test
<a class="jxr_linenumber" name="468" href="#468">468</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testResumeOnSocketTimeoutInChunk() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="469" href="#469">469</a>         String s = <span class="jxr_string">"5\000\r\000\n\00001234\r\n\0005\r\n56789\r\na\r\n0123456789\r\n\0000\r\n"</span>;
<a class="jxr_linenumber" name="470" href="#470">470</a>         SessionInputBuffer sessbuf = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/SessionInputBufferMock.html">SessionInputBufferMock</a>(
<a class="jxr_linenumber" name="471" href="#471">471</a>                 <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/io/TimeoutByteArrayInputStream.html">TimeoutByteArrayInputStream</a>(s.getBytes(<span class="jxr_string">"ISO-8859-1"</span>)), 16);
<a class="jxr_linenumber" name="472" href="#472">472</a>         InputStream in = <strong class="jxr_keyword">new</strong> ChunkedInputStream(sessbuf);
<a class="jxr_linenumber" name="473" href="#473">473</a> 
<a class="jxr_linenumber" name="474" href="#474">474</a>         byte[] tmp = <strong class="jxr_keyword">new</strong> byte[3];
<a class="jxr_linenumber" name="475" href="#475">475</a> 
<a class="jxr_linenumber" name="476" href="#476">476</a>         <strong class="jxr_keyword">int</strong> bytesRead = 0;
<a class="jxr_linenumber" name="477" href="#477">477</a>         <strong class="jxr_keyword">int</strong> timeouts = 0;
<a class="jxr_linenumber" name="478" href="#478">478</a> 
<a class="jxr_linenumber" name="479" href="#479">479</a>         <strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="480" href="#480">480</a>         <strong class="jxr_keyword">while</strong> (i != -1) {
<a class="jxr_linenumber" name="481" href="#481">481</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="482" href="#482">482</a>                 i = in.read(tmp);
<a class="jxr_linenumber" name="483" href="#483">483</a>                 <strong class="jxr_keyword">if</strong> (i &gt; 0) {
<a class="jxr_linenumber" name="484" href="#484">484</a>                     bytesRead += i;
<a class="jxr_linenumber" name="485" href="#485">485</a>                 }
<a class="jxr_linenumber" name="486" href="#486">486</a>             } <strong class="jxr_keyword">catch</strong> (InterruptedIOException ex) {
<a class="jxr_linenumber" name="487" href="#487">487</a>                 timeouts++;
<a class="jxr_linenumber" name="488" href="#488">488</a>             }
<a class="jxr_linenumber" name="489" href="#489">489</a>         }
<a class="jxr_linenumber" name="490" href="#490">490</a>         Assert.assertEquals(20, bytesRead);
<a class="jxr_linenumber" name="491" href="#491">491</a>         Assert.assertEquals(5, timeouts);
<a class="jxr_linenumber" name="492" href="#492">492</a>     }
<a class="jxr_linenumber" name="493" href="#493">493</a> 
<a class="jxr_linenumber" name="494" href="#494">494</a> }
<a class="jxr_linenumber" name="495" href="#495">495</a> 
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

